SystemOrganization addCategory: #MEG!
SystemOrganization addCategory: 'MEG-Model'!
SystemOrganization addCategory: 'MEG-Tests-Integration-Interaction'!
SystemOrganization addCategory: 'MEG-Tests-Integration-Movie'!
SystemOrganization addCategory: 'MEG-Tests-Unit'!

Object subclass: #HomeSiteCriteria
	instanceVariableNames: 'type name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Model'!

!HomeSiteCriteria class methodsFor: 'instance creation' stamp: 'SergioFedi 5/26/2016 09:03'!
type: aString

	^self new
		type: aString;
		yourself.! !

!HomeSiteCriteria methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 09:11'!
name: aString

	name := aString.! !

!HomeSiteCriteria methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 09:03'!
type: aString

	type := aString.! !

Object subclass: #MEGCharacter
	instanceVariableNames: 'name homeSiteCriteria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Model'!

!MEGCharacter class methodsFor: 'instance creation' stamp: 'SergioFedi 5/26/2016 09:08'!
named: aString homeSiteNamed: siteName

	^self new
		name: aString;
		homeSiteCriteria: (HomeSiteCriteria named: siteName);
		yourself.! !

!MEGCharacter class methodsFor: 'instance creation' stamp: 'SergioFedi 5/26/2016 09:02'!
named: aString homeSiteType: homeSiteTypeString

	^self new
		name: aString;
		homeSiteCriteria: (HomeSiteCriteria type: homeSiteTypeString);
		yourself.! !

!MEGCharacter methodsFor: 'accessing' stamp: 'SergioFedi 5/26/2016 08:55'!
homeSiteCriteria
	^ homeSiteCriteria! !

!MEGCharacter methodsFor: 'accessing' stamp: 'SergioFedi 5/26/2016 08:55'!
homeSiteCriteria: anObject
	homeSiteCriteria := anObject! !

!MEGCharacter methodsFor: 'as yet unclassified' stamp: 'SergioFedi 5/26/2016 08:56'!
name
	^ name! !

!MEGCharacter methodsFor: 'accessing' stamp: 'SergioFedi 5/26/2016 08:55'!
name: anObject
	name := anObject! !

Object subclass: #MEGSite
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Model'!

!MEGSite class methodsFor: 'instance creation' stamp: 'SergioFedi 5/26/2016 08:51'!
named: aString

	^self new name: aString.! !

!MEGSite methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:51'!
name
	^ name! !

!MEGSite methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 08:50'!
name: anObject
	name := anObject! !

Object subclass: #MEGSpawnCharacterAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Model'!

Object subclass: #MEGWorld
	instanceVariableNames: 'locations characters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Model'!

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 09:12'!
addCharacter: aMEGCharacter

	characters add: aMEGCharacter.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 09:11'!
addSite: aMEGSite

	locations add: aMEGSite.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:32'!
characters
	^ characters! !

!MEGWorld methodsFor: 'initialization' stamp: 'SergioFedi 5/26/2016 08:32'!
initialize

	super initialize.

	characters := OrderedCollection new.
	locations := OrderedCollection new.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:32'!
locations

	^locations.! !

TestCase subclass: #EruCreatesTheWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Tests-Integration-Movie'!

!EruCreatesTheWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:26'!
test_01_WorldCreation

	| world gandalf rivendel elrond spawn |
	world := MEGWorld new.
	rivendel := MEGSite named: 'Rivendel'.
	gandalf := MEGCharacter named: 'Gandalf' homeSiteType: 'Haven'.
	elrond := MEGCharacter named: 'Elrond' homeSiteNamed: 'Rivendel'.
	spawn := MEGSpawnCharacterAction new.
	
	world addSite: rivendel.
	world addCharacter: gandalf.
	world addCharacter: elrond.
	
! !

TestCase subclass: #MEGWorldTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Tests-Unit'!

!MEGWorldTest commentStamp: '<historical>' prior: 0!
A MEGWorldTest is a test class for testing the behavior of MEGWorld!

!MEGWorldTest methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:31'!
test_01_Creation

	| world |
	world := MEGWorld new.
	self assert: world locations isEmpty.
	self assert: world characters isEmpty.! !

TestCase subclass: #TheCompanyFormsAtRivendel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Tests-Integration-Interaction'!

!TheCompanyFormsAtRivendel methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 08:26'!
newWorld

	| world gandalf rivendel elrond spawn |
	world := MEGWorld new.
	rivendel := MEGSite named: 'Rivendel'.
	gandalf := MEGCharacter named: 'Gandalf' homeSiteType: 'Haven'.
	elrond := MEGCharacter named: 'Elrond' homeSiteNamed: 'Rivendel'.
	spawn := MEGSpawnCharacterAction new.
	
	world addSite: rivendel.
	world addCharacter: gandalf.
	world addCharacter: elrond.
	
	^world.! !

!TheCompanyFormsAtRivendel methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 09:34'!
test_01_GandalfRecruitsElrond

	| world rivendel gandalf elrond |
	world := self newWorld.
	rivendel := world siteNamed: 'Rivendel'.
	gandalf := world characterNamed: 'Gandalf'.
	elrond := world characterNamed: 'Elrond'.
	self assert: gandalf companies isEmpty.
	gandalf recruit: elrond at: rivendel.
	self assert: gandalf companies notEmpty.
	self assert: (gandalf companies first includes: elrond).! !

!TheCompanyFormsAtRivendel methodsFor: 'public' stamp: 'SergioFedi 5/25/2016 12:55'!
test_01a_ElrondSpawnsAtRivendel

	| world rivendel gandalf elrond spawn |
	world := self newWorld.
	rivendel := world siteNamed: 'Rivendel'.
	gandalf := world characterNamed: 'Gandalf'.
	elrond := world characterNamed: 'Elrond'.
	spawn := MEGSpawnCharacterAction on: world.
	
	self deny: (rivendel includes: elrond).
	self assert: elrond location isNil.
	spawn 
		world: world;
		character: elrond;
		alliedTo: gandalf;
		
		perform.
	self assert: (rivendel includes: elrond).
	self assert: elrond location = rivendel.! !

!TheCompanyFormsAtRivendel methodsFor: 'public' stamp: 'SergioFedi 5/25/2016 12:55'!
test_01b_ElrondSpawnsAtRivendel

	| world rivendel gandalf elrond spawn |
	world := self newWorld.
	rivendel := world siteNamed: 'Rivendel'.
	gandalf := world characterNamed: 'Gandalf'.
	elrond := world characterNamed: 'Elrond'.
	spawn := MEGSpawnCharacterAction on: world.
	
	self deny: (rivendel includes: elrond).
	self assert: elrond location isNil.
	spawn 
		world: world;
		character: elrond;
		alliedTo: gandalf;
		site: elrond homeSite;
		perform.
	self assert: (rivendel includes: elrond).
	self assert: elrond location = rivendel.! !

!TheCompanyFormsAtRivendel methodsFor: 'public' stamp: 'SergioFedi 5/25/2016 12:56'!
test_01c_ElrondSpawnsAtRivendel

	| world rivendel gandalf elrond spawn |
	world := self newWorld.
	rivendel := world siteNamed: 'Rivendel'.
	gandalf := world characterNamed: 'Gandalf'.
	elrond := world characterNamed: 'Elrond'.
	spawn := MEGSpawnCharacterAction on: world.
	
	self deny: (rivendel includes: elrond).
	self assert: elrond location isNil.
	spawn 
		world: world;
		character: elrond;
		alliedTo: gandalf;
		site: rivendel;
		perform.
	self assert: (rivendel includes: elrond).
	self assert: elrond location = rivendel.! !
